<?php

class RankController{

    protected function getMysql($account_id)
    {
        $mysql_conf = getMysqlConfig(crc32($account_id));
        $conn = new phpcommon\Mysql(array(
            'host' => $mysql_conf['host'],
            'port' => $mysql_conf['port'],
            'user' => $mysql_conf['user'],
            'passwd' => $mysql_conf['passwd'],
            'dbname' => 'gamedb2004_' . $mysql_conf['instance_id']
        ));
        return $conn;
    }

    protected function getRedis()
    {
        $key = 'game2004api';
        $redis_conf = getRedisConfig($key);
        $r = new phpcommon\Redis(array(
            'host' => $redis_conf['host'],
            'port' => $redis_conf['port'],
            'passwd' => $redis_conf['passwd'],
        ));
        return $r;
    }

    protected function getSeasonPoint($seaPoint_id)
    {
        $seaPoint_meta_table = require('../res/seasomPoint@seasomPoint.php');
        $seaPoint_meta = getSeasonPointConfig($seaPoint_meta_table, $seaPoint_id);
        $seaPoint = array(
            'id' => $seaPoint_meta['id'],
            'min' => $seaPoint_meta['min_point'],
            'max' => $seaPoint_meta['max_point'],
            'des' => $seaPoint_meta['des'],
        );
        return $seaPoint;
    }


    public function rankInfo()
    {
        $account_id = $_REQUEST['account_id'];
        //登录校验
        $login = loginVerify($account_id, $_REQUEST['session_id']);
        if (!$login) {
            phpcommon\sendError(ERR_USER_BASE + 1, 'session无效');
            return;
        }
        $conn = $this->getMysql($account_id);
        if (!$conn) {
            phpcommon\sendError(ERR_USER_BASE + 1, '没有这个玩家');
            return;
        }
        $kill_list = array();
        $kill_rank = 0;
        $win_list = array();
        $win_rank = 0;
        $user_list = array();
        $integral_rank = 0;
        $integral_list = array();
        $score = 0;
        $myname = '';
        $myavatar_url = '';
        //个人信息
        $row = $conn->execQueryOne('SELECT user_name, avatar_url, kills, alive_time, harm, win_times, game_times, integral FROM user ' .
                                   ' WHERE accountid=:accountid;',
                                   array(
                                       ':accountid' => $account_id
                                   ));
        if ($row) {
            $seaPoint_meta_table = require('../res/seasomPoint@seasomPoint.php');
            for ($ii = 1; $ii <= count($seaPoint_meta_table); $ii++) {
                $seaPoint = $this->getSeasonPoint($ii);
                if ($row['integral'] >= $seaPoint['min'] && $row['integral'] <= $seaPoint['max']
                || $seaPoint['max'] == -1) {
                    $rank = $ii;
                    break;
                }
            }
            if ($row['avatar_url'] == '' || $row['user_name'] == '') {
                $address = '../res/robot@robot' . 1 . '.php';
                $robot_meta_cluster = require($address);
                $i = Rand(1, 100);
                $robot_id = 1000 + $i;
                $robot_meta = getRobotConfig($robot_meta_cluster, $robot_id);
                $rob = array(
                    'name' => $robot_meta['name'],
                    'avatar_url' => $robot_meta['avatar_url'],
                );
                if ($row['user_name'] == '') {
                    $myname = $rob['name'];
                } else {
                    $myname = $row['user_name'];
                }
                if ($row['avatar_url'] == '') {
                    $myavatar_url = $rob['avatar_url'];
                } else {
                    $myavatar_url = $row['avatar_url'];
                }
            } else {
                $myname = $row['user_name'];
                $myavatar_url = $row['avatar_url'];
            }
            $myavatar_url = urldecode($myavatar_url);
            array_push($user_list, array(
                'account_id' => $account_id,
                'name' => $myname,
                'avatar_url' => $myavatar_url,
                'kill' => phpcommon\safediv($row['kills'], $row['game_times']),
                'alive'=> phpcommon\safediv($row['alive_time'], $row['game_times']),
                'harm' => phpcommon\safediv($row['harm'], $row['game_times']),
                'win_rate' => phpcommon\safediv($row['win_times'], $row['game_times']),
                'win_game' => $row['win_times'],
                'score' => $row['integral'],
                'level' => $rank,
            ));
        }
        ini_set('memory_limit','3072M');
        //击杀榜
        $r = $this->getRedis();
        $channel = phpcommon\extractChannel($account_id);
        $win_rank_db = $r->get("game2004api:win_rank_" . $channel);
        if ($_SERVER['HTTP_HOST'] == 'game2001api-banshu.kingsome.cn') {
            $win_rank_db = $r->get("game2004api_2001:win_rank_" . $channel);
        }
        $win_db = json_decode($win_rank_db);
        $i = 0;
        foreach ($win_db as $win) {
            $name = '';
            $avatar_url = '';
            if ($i > 49) {
                break;
            }
            if ($win_db[$i][0] == $account_id) {
                $win_rank = $i + 1;
            }
            if ($win_db[$i][2] == '' || $win_db[$i][1] == '') {
                if ($win_db[$i][0] == $account_id) {
                    $name = $myname;
                    $avatar_url = $myavatar_url;
                } else {
                    $address = '../res/robot@robot' . 1 . '.php';
                    $robot_meta_cluster = require($address);
                    $j = Rand(1, 100);
                    $robot_id = 1000 + $j;
                    $robot_meta = getRobotConfig($robot_meta_cluster, $robot_id);
                    $rob = array(
                        'name' => $robot_meta['name'],
                        'avatar_url' => $robot_meta['avatar_url'],
                    );
                    if ($win_db[$i][1] == '') {
                        $name = $rob['name'];
                    } else {
                        $name = $win_db[$i][1];
                    }
                    if ($win_db[$i][2] == '') {
                        $avatar_url = $rob['avatar_url'];
                    } else {
                        $avatar_url = $win_db[$i][2];
                    }
                }
            } else {
                $name = $win_db[$i][1];
                $avatar_url = $win_db[$i][2];
            }
            $url = urldecode($avatar_url);
            array_push($win_list, array(
                'account_id' => $win_db[$i][0],
                'name' => $name,
                'avatar_url' => $url,
                'kill' => $win_db[$i][3],
                'alive'=> $win_db[$i][4],
                'harm' => $win_db[$i][5],
                'win_rate' => $win_db[$i][6],
                'win_game' => $win_db[$i][7],
            ));
            $i++;
        }

        //积分榜
        $channel = phpcommon\extractChannel($account_id);
        $integral_rank_db = $r->get("game2004api:integral_rank_" . $channel);
        if ($_SERVER['HTTP_HOST'] == 'game2001api-banshu.kingsome.cn') {
            $integral_rank_db = $r->get("game2004api_2001:integral_rank_" . $channel);
        }
        $integral_db = json_decode($integral_rank_db);
        $i = 0;
        foreach ($integral_db as $integral) {
            $name = '';
            $avatar_url = '';
            if ($i > 49) {
                break;
            }
            if ($integral_db[$i][1] == '游客' || $integral_db[$i][1] == '极乐玩家') {
                continue;
            }
            $score = 0;
            $rank = 0;
            $seaPoint_meta_table = require('../res/seasomPoint@seasomPoint.php');
            for ($ii = 1; $ii <= count($seaPoint_meta_table); $ii++) {
                $seaPoint = $this->getSeasonPoint($ii);
                if ($integral_db[$i][8] >= $seaPoint['min'] && $integral_db[$i][8] <= $seaPoint['max']
                    || $integral_db[$i][8] >= $seaPoint['min'] && $seaPoint['max'] == -1)
                {
                    $rank = $ii;
                    break;
                }
            }
            if ($integral_db[$i][0] == $account_id) {
                $integral_rank = $i + 1;
            }
            if ($integral_db[$i][2] == '' || $integral_db[$i][1] == '') {
                if ($integral_db[$i][0] == $account_id) {
                    $name = $myname;
                    $avatar_url = $myavatar_url;
                } else {
                    $address = '../res/robot@robot' . 1 . '.php';
                    $robot_meta_cluster = require($address);
                    $j = Rand(1, 100);
                    $robot_id = 1000 + $j;
                    $robot_meta = getRobotConfig($robot_meta_cluster, $robot_id);
                    $rob = array(
                        'name' => $robot_meta['name'],
                        'avatar_url' => $robot_meta['avatar_url'],
                    );
                    if ($integral_db[$i][1] == '') {
                        $name = $rob['name'];
                    } else {
                        $name = $integral_db[$i][1];
                    }
                    if ($integral_db[$i][2] == '') {
                        $avatar_url = $rob['avatar_url'];
                    } else {
                        $avatar_url = $integral_db[$i][2];
                    }
                }
            } else {
                $name = $integral_db[$i][1];
                $avatar_url = $integral_db[$i][2];
            }
            $url = urldecode($avatar_url);
            array_push($integral_list, array(
                'account_id' => $integral_db[$i][0],
                'name' => $name,
                'avatar_url' => $url,
                'kill' => $integral_db[$i][3],
                'alive'=> $integral_db[$i][4],
                'harm' => $integral_db[$i][5],
                'win_rate' => $integral_db[$i][6],
                'win_game' => $integral_db[$i][7],
                'score' => $integral_db[$i][8],
                'level' => $rank,
            ));
            $i++;
        }

        echo json_encode(array(
            'errcode' => 0,
            'errmsg' => "",
            'user_list' => $user_list,
            'win_rank' => $win_rank,
            'win_list' => $win_list,
            'integral_rank' => $integral_rank,
            'integral_list' => $integral_list,
        ));
    }
}
